<?php  namespace MailVerify;
require_once(dirname(__DIR__) . "/init.php");
class Tools 
{
	private function __construct() 
	{
	}
	public static function getSystemURL() 
	{
		if( empty($GLOBALS["CONFIG"]) ) 
		{
			$result = \WHMCS\Database\Capsule::table("tblconfiguration")->where("setting", "SystemSSLURL")->first()->value;
			if( empty($result) ) 
			{
				$result = \WHMCS\Database\Capsule::table("tblconfiguration")->where("setting", "SystemURL")->first()->value;
			}
			if( empty($result) ) 
			{
				throw new \Exception("Unable to get WHMCS URL from database");
			}
		}
		else 
		{
			if( !empty($GLOBALS["CONFIG"]["SystemSSLURL"]) ) 
			{
				$result = $GLOBALS["CONFIG"]["SystemSSLURL"] . "/";
			}
			else 
			{
				if( ($result = $GLOBALS["CONFIG"]["SystemURL"]) ) 
				{
					$result = $GLOBALS["CONFIG"]["SystemURL"] . "/";
				}
				else 
				{
					throw new \Exception("Unable to get WHMCS URL from \$GLOBALS");
				}
			}
		}
		return (string) $result;
	}
	public static function getRandToken() 
	{
		return md5(mt_rand(1, 10) . time() . mt_rand(1, 10));
	}
	public static function getLinkTag($url = "", $name = "", $css = "") 
	{
		$css = (empty($css) ? "" : "class=\"" . $css . "\"");
		return (string) ("<a href=\"" . $url . "\" target=\"_blank\" " . $css . " >" . $name . "</a>");
	}
	public static function getJumpURL($url = "", $js = false) 
	{
		if( $js ) 
		{
			$result = "<script type=\"text/javascript\">location=\"" . $url . "\";</script>";
		}
		else 
		{
			$result = header("Location: " . $url);
		}
		return (string) $result;
	}
	public static function checkArray(array $need = array( ), array $array = array( )) 
	{
		foreach( $need as $key => $value ) 
		{
			if( empty($array[$key]) ) 
			{
				throw new \Exception($value);
			}
		}
	}
	public static function getAdminUser() 
	{
		$adminUser = (object) \WHMCS\Database\Capsule::table("tbladmins")->select("username")->first();
		$adminUser = $adminUser->username;
		if( empty($adminUser) ) 
		{
			throw new \Exception("Unable to get admin user from database");
		}
		return (string) $adminUser;
	}
	public static function getWebContent(array $setting = array( )) 
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $setting["url"]);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_TIMEOUT, (empty($setting["timeout"]) ? 5 : $setting["timeout"]));
		curl_setopt($ch, CURLOPT_MAXREDIRS, 3);
		curl_setopt($ch, CURLOPT_FRESH_CONNECT, 1);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLOPT_USERAGENT, (empty($setting["user-agent"]) ? "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:51.0) Gecko/20100101 Firefox/51.0" : $setting["user-agent"]));
		if( !empty($setting["post"]) ) 
		{
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($setting["post"]));
		}
		$data = curl_exec($ch);
		if( $setting["utf8"] ) 
		{
			$data = mb_convert_encoding($data, "utf8", "gbk");
		}
		if( curl_error($ch) ) 
		{
			throw new \Exception("无法取得网页内容, 错误码: #" . curl_errno($ch) . " 错误原因: " . curl_error($ch));
		}
		curl_close($ch);
		if( empty($data) ) 
		{
			throw new \Exception("取得的网页内容为空");
		}
		if( !empty($setting["json"]) ) 
		{
			$data = json_decode($data, true);
			if( $data == "null" ) 
			{
				throw new \Exception("网页返回内容并非 JSON 格式");
			}
		}
		return $data;
	}
	public static function verifyLicense($license) 
	{
		$data = array();
		$data["status"] == "Active";
		return $data;
	}
}